﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.ServiceModel;
using System.IO;
using System.Runtime.Serialization;

namespace ACL.P2P
{
    
    [ServiceContract]
    public interface IPeerToPeer
    {
        [OperationContract]
        RemoteFileInfo GetFile(DownloadRequest file);

        [OperationContract]
        void PutFile(RemoteFileInfo file);

        [OperationContract]
        List<DownloadRequest> RequestFileInfos();    

       

    }

    [MessageContract]
    public class DownloadRequest
    {
        [MessageBodyMember]
        public string FileName;
    }


    [MessageContract]
    public class RemoteFileInfo : IDisposable
    {
        [MessageHeader(MustUnderstand = true)]
        public string FileName;

        [MessageHeader(MustUnderstand = true)]
        public long Length;

        [MessageBodyMember(Order = 1)]
        public System.IO.Stream FileByteStream;

        public void Dispose()
        {
            if (FileByteStream != null)
            {
                FileByteStream.Close();
                FileByteStream = null;
            }
        }
    }
}